//+------------------------------------------------------------------+
//|                    Holt double exponential smoothing - trend.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   2
#property indicator_level1   0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern double estimatePeriod = 14.33;
extern double trendPeriod    = 10;
extern int    Price          = PRICE_CLOSE;

//
//
//
//
//

double emaBuffer[];
double wrkBuffer[];
double alpha;
double gamma;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,wrkBuffer);
   SetIndexBuffer(1,emaBuffer);
      estimatePeriod = MathMax(estimatePeriod,1);
      trendPeriod    = MathMax(trendPeriod,1);
               alpha = 2.0 /(1.0+estimatePeriod);
               gamma = 2.0 /(1.0+trendPeriod);
      IndicatorShortName("Holt des trend ("+DoubleToStr(estimatePeriod,2)+","+DoubleToStr(trendPeriod,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>=(Bars-3))
         {
            emaBuffer[i] = price;
            wrkBuffer[i] = price-emaBuffer[i+1];
            continue;
         }
         
         emaBuffer[i] = alpha*price+(1-alpha)*(emaBuffer[i+1]+wrkBuffer[i+1]);
         wrkBuffer[i] = gamma*(emaBuffer[i]-emaBuffer[i+1]) + (1-gamma)*wrkBuffer[i+1];
   }
   return(0);
}